#!/usr/bin/env python
# coding: utf-8

import gnupg
import jj_crypto as cr
from secretsharing import PlaintextToHexSecretSharer as ss
import getpass
import secrets

gpgpw = None

gpghome = ".gpg"
name_real = "Volby do SKAS FMFI UK"
name_email = "volbyskas@fmph.uniba.sk"

def recoverPw():
  global gpgpw
  k = int(input("Pocet pritomnych clenov komisie:"))
  shares = []
  for i in range(k):
    while True:
      try:
        id = int(input("Cislo clena:"))
        pw = getpass.getpass("Heslo clena "+str(id)+":")
        with open("pw/pw"+str(id), "rb") as f:
          salt = f.read(16)
          cipher = f.read()
        keysalt = cr.pw2key(pw, salt)
        share = cr.decrypt(keysalt.key, cipher)
        shares.append(share)
        break
      except:
        print("Chyba pri zadavani udajov clena komisie")

  gpgpw = ss.recover_secret(shares)

def decrypt(s):
  gpg = gnupg.GPG(gnupghome=gpghome)
  plain = gpg.decrypt(s, passphrase=gpgpw)
  if not plain.ok:
    return None
  else:
    return str(plain)
    
def sign_file(file):
  gpg = gnupg.GPG(gnupghome=gpghome)
  gpg.encoding='utf-8'
  signed = gpg.sign_file(file, detach=True, passphrase=gpgpw)
  if not signed:
    return None
  else:
    return str(signed)
  
def genKey():
  abeceda="abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789!@#$%^&*()-_=+[]{};'|,.<>/?";

  gpg = gnupg.GPG(gnupghome=gpghome)
  randpass = "".join((secrets.choice(abeceda) for i in range(64)));
  input_data = gpg.gen_key_input(name_email=name_email, name_real=name_real, passphrase=randpass)
  key = gpg.gen_key(input_data)

  pub_key = gpg.export_keys(key.fingerprint)

  with open("data/publickey.asc", 'w') as pubf:
      pubf.write(pub_key)
      
  n = int(input("Pocet clenov volebnej komisie: "))
  k = int(input("Pocet potrebnych clenov na scitanie: "))

  shares = ss.split_secret(randpass, k, n)

  i=1
  for share in shares:
    fn = "pw"+str(i)
    while True:
      pw = getpass.getpass("Zadaj heslo člena komisie č. "+str(i)+": ")
      pw2 = getpass.getpass("Zadaj heslo člena komisie č. "+str(i)+": ")
      if pw == pw2:
        break
      else:
        print("Heslá sa nezhodujú")
    keysalt = cr.pw2key(pw)
    cipher = cr.encrypt(keysalt.key, share)
    with open("pw/pw"+str(i), "wb") as f:
      f.write(keysalt.salt)
      f.write(cipher)
    i = i+1
