#!/usr/bin/env python3
# coding: utf-8

import sys
sys.path.insert(0, "/var/www/sevas/lib")

import cgi
import sqlite3
import os
import functions as f
import datetime as dt
import config as c

d = dt.datetime.now()
if d < c.START or d > c.END:
    f.page_header()
    print("Hlasovací systém je uzavretý. Hlasovanie prebieha(lo) v čase od %s do %s." % (str(c.START), str(c.END)))

elif 'uid' in os.environ:
    login = os.environ['uid']

    form = cgi.FieldStorage()
    vote = form.getvalue('vote')

    connection = sqlite3.connect("../db/persons.sqlite")
    cursor = connection.cursor()
    cursor.execute("SELECT COUNT(*) FROM voters WHERE login=?", (login,))
    result = cursor.fetchall()
    connection.close()

    f.page_header()

    sent = False
    if vote == None:
        print('<font color="red">Nastala chyba pri odoslaní hlasu. Skúste, prosím znova. V prípade pretrvávajúcich problémov sa obráťte na volebnú komisiu.</font>')
    elif result != [(0,)]:
        connection = sqlite3.connect("../db/votes.sqlite")
        cursor = connection.cursor()
        cursor.execute("SELECT COUNT(*) FROM votes WHERE login=?", (login,))
        result2 = cursor.fetchall()
        msg=""
        if result2 == [(0,)]:
            cursor.execute("INSERT INTO votes (login, vote) VALUES(?, ?)", (login, vote,))
            sent = True
            msg = '<font color="green">Hlas bol úspešne zaznamenaný.</font>'
        else:
            cursor.execute("SELECT CASE WHEN vote='0' THEN 0 ELSE 1 END FROM votes WHERE login=?", (login,))
            result3 = cursor.fetchall()
            if result3 ==[(0,)]:
                print( """Už ste hlasovali papierovo. Nemožno už hlasovať elektronicky.""")
            else:
                cursor.execute("UPDATE votes SET vote = ? WHERE login = ?", (vote, login,))
                sent = True
                msg = '<font color="green">Hlas bol úspešne zaznamenaný, predchádzajúci hlas bol nahradený.</font>'
        connection.commit()
        if sent:
            print(msg)
            print( """<br>Odoslaný hlas:.<br>
    <textarea rows="10" cols="80" id="display_vote" readonly>%s</textarea>""" % vote)

    else:
        print( '<font color="red">Nie ste v zozname voličov, obráťte sa na volebnú komisiu!</font>')
    
    print("""<div><button onclick="window.location.href='/Shibboleth.sso/Logout'">Odhlásiť sa</button></div>""")

else:
    f.page_header()
    print('<p><font color="red">Prístup zakázaný! Nie ste prihlásený!</font></p>')

f.page_footer()