#!/usr/bin/env python3
# coding: utf-8

import sys
sys.path.insert(0, "/var/www/sevas/lib")

import functions as f
import config as c
import cgi, cgitb
import os
import datetime as dt
import sqlite3

d = dt.datetime.now()
if d < c.START or d > c.END:
    f.page_header()
    print("Hlasovací systém je uzavretý. Hlasovanie prebieha(lo) v čase od %s do %s." % (str(c.START), str(c.END)))

elif 'uid' in os.environ:
    login = os.environ['uid']
    displayname = os.environ['displayName']
    
    connection = sqlite3.connect("../db/persons.sqlite")
    cursor = connection.cursor()
    cursor.execute("SELECT COUNT(*) FROM voters WHERE login=?", (login,))
    result = cursor.fetchall()
    connection.close()
    if result != [(1,)]:
        f.page_header()
        print("Osoba s prihlasovacím menom %s nie je v zozname voličov. Ak ste oprávnený volič, obráťte sa na volebnú komisiu" % (login))
    else:
        f.page_header("""
<script type="text/javascript" src="static/dist/openpgp.min.js"></script>
<script type="text/javascript" src="static/publickey.js"></script>
<script type="text/javascript" src="static/form_processing.js"></script>
    """)

        print("<h3>Vitajte v aplikácii pre elektronické voľby, ste prihlásený/á ako %s (%s)</h3>" % (displayname, login))
        print("<h3>Označenie volieb: %s</h3>" % (c.DESC))
        print("<h3>Hlasovanie je možné od %s do %s.</h3>" % (str(c.START), str(c.END)))
        print("<h3>Na hlasovacom lístku môžete označiť najviac %d kandidátov.</h3>" % (c.CAND_NUM))
        print("<p>Po označení kandidátov, ktorým chcete dať svoj hlas, vytvorte zašifrovaný hlasovací lístok tlačidlom Vytvor hlas a po úspešnom vyplnení políčka nižšie hlasovací lístok odošlite tlačidlom Pošli hlas.</p>")

        print('<div class="listok">')
        print('<form name="voting" method="post" action="collection.py">')
        f.print_form_field(f.select_candidates())

        print("""<div class="tlacidla">
<button type="button" id="vytvor" class="btn btn-primary" onclick="processForm(%s);">Vytvor hlas</button>
<input type="submit" id="submit" disabled class="btn btn-primary" name ="submit" value="Pošli hlas"></div>
Odosielaný hlas:<br>
<textarea rows="10" cols="80" id="vote" name="vote" readonly></textarea>
</form>""" % (str(c.CAND_NUM)))
        print('</div>')

else:
    f.page_header()
    print("<p>Nie ste platne prihlásení.</p>")

f.page_footer()


