#!/usr/bin/env python3
# coding: utf-8
import sqlite3

# this function selects candidates from the database
def select_candidates():
    connection = sqlite3.connect("../db/persons.sqlite")
    cursor = connection.cursor()
    cursor.execute("SELECT * FROM candidates")
    result = cursor.fetchall()

    connection.close()

    return result

def select_voters(login):
    connection = sqlite3.connect("../db/persons.sqlite")
    cursor = connection.cursor()
    cursor.execute("SELECT COUNT(*) FROM voters WHERE UKLogin=?", (login,))
    result = cursor.fetchall()

    connection.close()

    return result


def print_form_field(data):
    levels = [ None, 'bakalársky', 'magisterský', 'doktorandský' ] 
    print("<table>")
    print("<tr><th colspan='6'>Hlasovací lístok")
    print("<tr><th><th>p.č.<th>Meno a priezvisko<th>štud. prog.<th>stupeň<th>rok št.")
    for i in data:
        idc = i[0] # candidate ID from the db
        name = i[1] # name
        prog = i[2] # st. prog
        level = levels[i[3]] # st. level
        year = i[4] # st. year

        """
        #print '<fieldset>'
        print('<div class="form-group">')
        print('<legend>%d. %s %s %s %s. r.</legend>' % (idc, name, prog, level, year))
        print('<input type = "radio" name = "%s" class="hlas" value = "1"> Áno ' % (idc))
        print('<input type = "radio" name = "%s" class="hlas" value = "2"> Nie ' % (idc))
        print('<input type = "radio" name = "%s" class="hlas" value = "3" checked> Zdržal som sa' % (idc))
        #print '</fieldset>'
        print('</div>')
        """
        #print('<div class="form-group">')
        print('<tr><td><input type = "checkbox" name = "%s" class = "hlas" value = "1">' % (idc))
        print('<td>%s.<td>%s<td>%s<td>%s<td style="text-align: right;">%s.' % (idc, name, prog, level, year))
        #print('</div>')
    print("</table>")

def page_header(additional_head = ""):
    print("""Content-type: text/html

<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<link rel="stylesheet" href="static/main.css">
<title>Volebný systém FMFI UK</title>
    """)
    if additional_head:
        print(additional_head)
    print("""</head>
<body>

<h1 class="banner">
<img src="static/FMFI_logo.png" class="logo">Volebný systém FMFI UK
</h1>
    """)

def page_footer():
    print("</body>\n</html>")
